﻿
Imports System
Imports System.Windows.Forms
Imports Microsoft.VisualBasic
Imports System.Data.SqlClient
Public Class BackupRestore
    ''' <summary>
    '''  Hi guy ! This dynamic link library writed by Ali Manam
    ''' --------------------------------------------------------
    ''' For any question about this code contact me by e-mail
    ''' | alimanam@gmail.com |
    ''' --------------------------------------------------------
    ''' </summary>
    ''' <remarks></remarks>
    Private clicked As Boolean = False
    Private Function Databases(ByVal instance As String) As String()
        Dim basesSys() As String = {"master", "model", "msdb", "tempdb"}
        Dim bases() As String
        Dim dt As New DataTable
        Dim sCnn As String = "Server=" & instance & "; " & "database=master; integrated security=yes"
        Dim sel As String = "SELECT name FROM sysdatabases"

        Try
            Dim da As New SqlDataAdapter(sel, sCnn)
            da.Fill(dt)
            ReDim bases(dt.Rows.Count - 1)
            Dim k As Integer = -1
            For i As Integer = 0 To dt.Rows.Count - 1
                Dim s As String = dt.Rows(i).Item("name").ToString()
                If Array.IndexOf(basesSys, s) = -1 Then
                    k += 1
                    bases(k) = s
                End If
            Next
            If k = -1 Then Return Nothing
            ReDim Preserve bases(k)
            Return bases
        Catch ex As Exception
            MsgBox(Err.Description, MsgBoxStyle.Exclamation)
        End Try
        Return Nothing
    End Function
    Private Function instanceInstalled() As String()
        Dim rk As Microsoft.Win32.RegistryKey
        rk = Microsoft.Win32.Registry.LocalMachine.OpenSubKey( _
                    "SOFTWARE\Microsoft\Microsoft SQL Server", True)
        Dim inst() As String
        inst = CType(rk.GetValue("InstalledInstances"), String())
        Return inst
    End Function
    Private Sub FillData()
        Try
            Me.cboInstance.Items.Clear()
            Me.cbodBases.Items.Clear()
        Catch ex As Exception
            ' Nothing :-)
        End Try
        Try
            Dim instances() As String
            instances = instanceInstalled()
            For Each s As String In instances
                If s = "MSSQLSERVER" Then
                    Me.cboInstance.Items.Add("(local)")
                Else
                    Me.cboInstance.Items.Add("(local)\" & s)
                End If
            Next
            If cboInstance.Items.Count > 0 Then
                Me.cboInstance.SelectedIndex = 0
            End If

            Dim dbases() As String = Databases(cboInstance.Text)
            If Not dbases Is Nothing Then
                Me.cbodBases.Items.AddRange(dbases)
            End If

            If Me.cbodBases.Items.Count > 0 Then
                Me.cbodBases.SelectedIndex = 0
            End If
        Catch ex As Exception
            MsgBox(Err.Description, MsgBoxStyle.Exclamation)
        End Try
    End Sub
    Private Sub Backup()
        Dim sBackup As String = "BACKUP DATABASE " & Me.cbodBases.Text & _
                        " TO DISK = N'" & Me.txtpath.Text & _
                        "' WITH NOFORMAT, NOINIT, NAME =N'" & Me.cbodBases.Text & ".bak" & _
                        "-Full Database Backup',SKIP, STATS = 10"

        Dim csb As New SqlConnectionStringBuilder
        csb.DataSource = Me.cboInstance.Text
        csb.InitialCatalog = Me.cbodBases.Text
        csb.UserID = txtuser.Text '  "sa"
        csb.Password = txtpass.Text ' "sa"
        csb.IntegratedSecurity = True

        Using con As New SqlConnection(csb.ConnectionString)
            Try
                con.Open()
                Dim cmdBackUp As New SqlCommand(sBackup, con)
                cmdBackUp.ExecuteNonQuery()
                con.Close()
                con.ClearAllPools()
                MsgBox("عملیات پشتیبان گیری با موفقیت انجام شد", MsgBoxStyle.Information)
            Catch ex As Exception
                MsgBox(Err.Description, MsgBoxStyle.Exclamation)
            End Try
        End Using

    End Sub

    Private Sub BackupRestore_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Me.Dispose()
        Me.Close()
    End Sub
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        FillData()
        Clearduplicatedb()
        tooltip.SetToolTip(btn_setting, "استفاده از حالت پیشرفته")
    End Sub
    Private Sub Clearduplicatedb()
        Dim bases() As String = Databases(cboInstance.Text)
        Me.cbodBases.Items.Clear()
        If Not bases Is Nothing Then
            Me.cbodBases.Items.AddRange(bases)
        End If
        If Me.cbodBases.Items.Count > 0 Then
            cbodBases.SelectedIndex = 0
        End If
    End Sub
    Private Sub cboInstance_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboInstance.SelectedIndexChanged
        Try
            Dim bases() As String = Databases(cboInstance.Text)
            Me.cbodBases.Items.Clear()
            If Not bases Is Nothing Then
                Me.cbodBases.Items.AddRange(bases)
            End If
            If Me.cbodBases.Items.Count > 0 Then
                cbodBases.SelectedIndex = 0
            End If
        Catch ex As Exception
            MsgBox(Err.Description, MsgBoxStyle.Exclamation)
        End Try
    End Sub

    Private Sub btn_selectpath_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_selectpath.Click
        contexmnu1.Show(btn_selectpath, 0, 0)
    End Sub

    Private Sub btn_backup_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_backup.Click
        Try
            If txtpath.Text = String.Empty Then
                MsgBox("لطفاً مسیر ذخیره سازی فایل پشتیبان را مشخص نمائید", MsgBoxStyle.Exclamation)
            ElseIf cboInstance.Text = String.Empty Then
                MsgBox("سرویس دهنده یافت نشد", MsgBoxStyle.Exclamation)
            ElseIf cbodBases.Text = String.Empty Then
                MsgBox("پایگاه داده ایی جهت عملیات پشتیبان گیری یافت نشد", MsgBoxStyle.Exclamation)
            Else
                Backup()
            End If
        Catch ex As Exception
            MsgBox(Err.Description, MsgBoxStyle.Exclamation)
        End Try
    End Sub

    Private Sub btn_setting_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_setting.Click
        If clicked = False Then
            btn_setting.Image = imglist.Images(1)
            clicked = True
            Me.Height = 300
            tooltip.SetToolTip(btn_setting, "استفاده از حالت پیش فرض")
        Else
            btn_setting.Image = imglist.Images(0)
            clicked = False
            Me.Height = 230
            tooltip.SetToolTip(btn_setting, "استفاده از حالت پیشرفته")
        End If
    End Sub
    Private Sub Restore()
        Dim sBackup As String = "RESTORE DATABASE " & Me.cbodBases.Text & _
                        " FROM DISK = '" & Me.txtpath.Text & "'" & _
                        " WITH REPLACE"
        Dim csb As New SqlConnectionStringBuilder
        csb.DataSource = Me.cboInstance.Text
        csb.InitialCatalog = "master"
        csb.IntegratedSecurity = True
        csb.UserID = txtuser.Text '  "sa"
        csb.Password = txtpass.Text ' "sa"

        Using con As New SqlConnection(csb.ConnectionString)
            Try
                con.Open()
                Me.Cursor = Cursors.WaitCursor
                Dim cmdBackUp As New SqlCommand(sBackup, con)
                cmdBackUp.ExecuteNonQuery()
                con.Close()
                con.ClearAllPools()
                Me.Cursor = Cursors.Default
                MsgBox("عملیات بازیابی با موفقیت انجام شد", MsgBoxStyle.Information)
            Catch ex As Exception
                MsgBox(Err.Description, MsgBoxStyle.Exclamation)
            End Try
        End Using

    End Sub
    Private Sub btn_restory_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_restory.Click
        Try
            If txtpath.Text = String.Empty Then
                MsgBox("لطفاً مسیر بازیابی را مشخص نمائید", MsgBoxStyle.Exclamation)
            ElseIf cboInstance.Text = String.Empty Then
                MsgBox("سرویس دهنده یافت نشد", MsgBoxStyle.Exclamation)
            ElseIf cbodBases.Text = String.Empty Then
                MsgBox("پایگاه داده ایی جهت عملیات بازیابی یافت نشد", MsgBoxStyle.Exclamation)
            Else
                Restore()
            End If
        Catch ex As Exception
            MsgBox(Err.Description, MsgBoxStyle.Exclamation)
        End Try
    End Sub

    Private Sub mnu_save_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnu_save.Click
        Dim dialog As New SaveFileDialog
        dialog.Filter = "SQL DB Backup(*.bak)|*.bak"
        If dialog.ShowDialog = Windows.Forms.DialogResult.OK Then
            txtpath.Text = dialog.FileName
        End If
    End Sub

    Private Sub mnu_Restore_path_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnu_Restore_path.Click
        Dim dialog As New OpenFileDialog
        dialog.Filter = "SQL DB Backup(*.bak)|*.bak"
        If dialog.ShowDialog = Windows.Forms.DialogResult.OK Then
            txtpath.Text = dialog.FileName
        End If
    End Sub

End Class
